/*
  $Header: /export/home/lord/src/tube/RCS/cfg.c,v 1.4 1996/01/12 19:12:16 lord Exp $

  $Log: cfg.c,v $
  Revision 1.4  1996/01/12 19:12:16  lord
  Some brush up with lint

  Revision 1.3  1996/01/02 20:21:10  lord
  Small bug in trim() fixed

  Revision 1.2  1996/01/02 20:16:39  lord
  Add comment

  Revision 1.1  1995/12/29 23:31:51  lord
  Initial revision

 */


/*
  I wrote this source 5 years ago and it defenetily needs
  to be rewritten.
  
  lord.
  */

#include "cfg.h"
#include <stdio.h>
#include <string.h>

#ifdef DOS
# include <alloc.h>
#else
# include <malloc.h>
#endif

#include <stdlib.h>

char *trim(char *);
void delchr(char *);

char *cfgfind(char *s1,struct Dict *dict)
{
    int i,r;

    r=i=0;
    while(dict[i].s1 && dict[i].s2 && r<=0) {
        if((r=strcmp(dict[i].s1,s1))==0) return dict[i].s2;
	i++;
    }
    return NULL;
}

char *cfgifind(char *s1,struct Dict *dict)
{
    int i,r;

    r=i=0;
    while(dict[i].s1 && dict[i].s2 && r<=0) {
        if((r=strcasecmp(dict[i].s1,s1))==0) return dict[i].s2;
	i++;
    }
    return NULL;
}

char *cfgset(char *s1,char *s2,struct Dict *dict)
{
    int i;
    i=0;
    while(dict[i].s1 && dict[i].s2) {
        if(strcmp(dict[i].s1,s1)==0) {
	    free(dict[i].s2);
	    dict[i].s2=strdup(s2);
	    return dict[i].s2;
        };
	i++;
    }
    return NULL;
}

int writecfg(char *name,struct Dict *dict)
{
    FILE *f;
    int i;

    if((f=fopen(name,"wb"))==NULL) return CFG_CANTWRITE;

    i=0;
    while(dict[i].s1 && dict[i].s2) {
        fprintf(f,"%s\t\t%s\n",dict[i].s1,dict[i].s2);
	i++;
    }
    fclose(f);
    return CFG_OK;
}

void freecfg(struct Dict *dict)
{
    int i;
    if(dict==NULL) return;
    i=0;
    while(dict[i].s1 && dict[i].s2) {
	free(dict[i].s1);
	free(dict[i].s2);
	i++;
    }
    free(dict);
}

int readcfg(char *name,struct Dict **dict)
{
    int n,i;
    FILE *f;
    char s[MAXCFGLINE];
    char *ps1,*ps2;

    if((f=fopen(name,"rb"))==NULL) return CFG_BADCFG;
    n=0;
    while(!feof(f)) {
	*s=NULL;
	fgets(s,MAXCFGLINE-2,f);
	if(*s!='#' && *s!=0 && *s!=' ' && *s!='\t' && *s!=0x0d && *s!=0x0a) n++;
    }
#ifdef CFG_DEBUG
    fprintf(stderr,"\nCONFIG: %d record found\n",n);
#endif
    if(n<=0) return CFG_EMPTYCFG;
    *dict=(struct Dict *)malloc((n+3)*sizeof(struct Dict));
    fseek(f,0l,SEEK_SET); /* rewind */
    i=0;
    while(i<n && !feof(f)) {
	fgets(s,MAXCFGLINE-2,f);
	if(*s!='#' && *s!=0 && *s!=' ' && *s!='\t' && *s!=0x0d && *s!=0x0a) {
	    if((ps1=strchr(s,'#'))!=NULL) *ps1=NULL; /* comments... */
	    (void)trim(s);
	    if((ps1=strtok(s," \t"))==NULL) ps1=""; else trim(ps1);
	    if((ps2=strchr(s,0)+1)==NULL)   ps2=""; else trim(ps2); 
	    (*dict)[i].s1=strdup(ps1);
	    (*dict)[i].s2=strdup(ps2);
	    i++;
#ifdef CFG_DEBUG
	    fprintf(stderr,"CONFIG: record %d : %s %s\n",i,ps1,ps2);
#endif
	}
    }	
    (*dict)[i].s1=0;
    (*dict)[i].s2=0;
    sortcfg(*dict,i);
#ifdef CFG_DEBUG
    printcfg(*dict);
#endif
    return CFG_OK;
}

void reversecfg(struct Dict *dict)
{
    int i;
    char *s;

    i=0;
    while(dict[i].s1 && dict[i].s2) {
        s=dict[i].s1;
        dict[i].s1=dict[i].s2;
        s=dict[i].s2=s;
	i++;
    }
    sortcfg(dict,i);
}

void sortcfg(struct Dict *dict,int nel)
{
    qsort((void *) dict,nel,sizeof(* dict),cfg_entry_cmp);
}

int cfg_entry_cmp(const void *a,const void *b)
{
    return(strcmp(
	((struct Dict *) a)->s1,
	    ((struct Dict *) b)->s1)
    );
}

#ifdef CFG_DEBUG

void printcfg(dict)
    struct Dict *dict;
{
    int i;
    char *s;

    i=0;
    while(dict[i].s1 && dict[i].s2) {
	printf("%s\t\t\t%s\n",dict[i].s1,dict[i].s2);
	i++;
    }
}

#endif


char *trim(char *s)   /* remove whitespace at the begining and the end of line */
{
    char *tmp;
    
    while(*s==' ' || *s=='\t' || *s=='\n' || *s=='\r') delchr(s); /* I can't use iswhite() because of improper handling of russian letters. (sign..) */
    tmp=s+strlen(s)-1;
    while((*tmp==' ' || *tmp=='\t' || *tmp==0x0d || *tmp==0x0a) && tmp!=s ) tmp--;    
    if(tmp!=s) *(tmp+1)=NULL;
    return s; 
                                                                 
}

void delchr(char *s)
{
    while((*s=*(s+1))!=NULL) s++;
}
